/*!
* @file Building.h
* @brief 施設のプロトタイプ宣言
* @date 2014/02/01
* @author Deskull
* 2014 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "GameElement.h"

namespace Deeangband
{

	/*! 
	* @class Building
	* @brief 施設のクラス
	*/
	class Building : public GameElement
	{
	private:

		NAME buildingName;

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param fileVersion ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int fileVersion) 
		{
			archive & BOOST_SERIALIZATION_NVP(buildingName);
		}

	public:

		/*! 
		* @brief Buildingクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		Building::Building(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief Buildingクラスコンストラクタ
		*/
		Building::Building(void);

		/*! 
		* @brief Buildingクラスデストラクタ
		*/
		Building::~Building(void);

		/*! 
		* @brief 施設名を返す
		* @return 施設名
		*/
		NAME Building::GetBuildingName(void);

	};

}